﻿local E = AleaUI
local CBF = E:Module("ClassBars")

local class1, class2
local currentSpec

local config = {
	['PRIEST'] = {
		[1] = { enable = false },
		[2] = { enable = false },
		[3] = { enable = true },
	},
	['DRUID'] = {
		[1] = { enable = true },
		[2] = { enable = true },
		[3] = { enable = true },
		[4] = { enable = true },
	},
	['ROGUE'] = {
		[1] = { enable = true },
		[2] = { enable = true },
		[3] = { enable = true },
	},
	['PALADIN'] = {
		[1] = { enable = true },
		[2] = { enable = true },
		[3] = { enable = true },
	},
	['WARLOCK'] = {
		[1] = { enable = true },
		[2] = { enable = true },
		[3] = { enable = true },	
	},
	['MONK'] = {
		[1] = { enable = true },
		[2] = { enable = true },
		[3] = { enable = true },	
	},
	['SHAMAN'] = {
		[1] = { enable = true },
		[2] = { enable = true },
		[3] = { enable = true },	
	},
	['DEATHKNIGHT'] = {
		[1] = { enable = true },
		[2] = { enable = true },
		[3] = { enable = true },
	},
	['MAGE'] = {
		[1] = { enable = true },
		[2] = { enable = true },
		[3] = { enable = true },
	},
	['DEMONHUNTER'] = {
		[1] = { enable = true },
		[2] = { enable = true },
	}
}

E.default_settings.classBars = config

local function ClassBarUpdate(f, unit)
	class1, class2 = UnitClass("player")
	currentSpec = GetSpecialization()
	
	if currentSpec and currentSpec > 0 then
	--	print(currentSpec)
		CBF:Activate(class2, currentSpec)
	end
end


CBF.ClassBarUpdate = ClassBarUpdate

function CBF:AddClassBar(class, spec, func)
	if not self.Exists then self.Exists = {} end
	if not self.Exists[class] then self.Exists[class] = {} end
	if not self.Exists[class][spec] then self.Exists[class][spec] = func end
end

local function OnEvent(self, event, ...)
	self[event](self, event, ...)
end

function CBF:Activate(class, spec)
	spec = spec or "any"
	if not self.Exists then self.Exists = {} end
	if not self.Exists[class] then self.Exists[class] = {} end
	if not self.Done then self.Done = {} end	
	if not self.Done[class] then self.Done[class] = {} end	
	if not self.Done[class][spec] then
	
		self.Done[class][spec] = self.Exists[class][spec] and self.Exists[class][spec]() or nil
		
		if self.Done[class][spec] then
			self.Done[class][spec].Register = self.Done[class][spec].Register or function(self)
				for k, v in pairs(self.eventlist) do
					if v ~= "" then
						self:RegisterUnitEvent(k, v)
					else
						self:RegisterEvent(k)
					end
				end
				
				if self.Update then
					self:Update()
				end
				
				self:SetScript("OnEvent", OnEvent)
					
				self:Show()
			end
			
			self.Done[class][spec].Enable = self.Done[class][spec].Enable or function(self)
				self:Register()
			end
			
			self.Done[class][spec].Disable = self.Done[class][spec].Disable or function(self)
				self:UnregisterAllEvents()
				self:Hide()
			end
		end
	end
	
	if self.CurrentAcive ~= spec then
		if self.CurrentAcive then
			self.Done[class][self.CurrentAcive]:Disable()
		end
		
		if self.Done[class][spec] then
			self.Done[class][spec]:Enable()
			self.CurrentAcive = spec			
			self.CurrentActiveClassBar = self.Done[class][spec]
		else
			self.CurrentAcive = nil
			self.CurrentActiveClassBar = nil
		end
	end
	
	if self.Done[class] and self.Done[class][spec] then
		if E.db.classBars[class][spec].enable then
			self.Done[class][spec]:Enable()
		else
			self.Done[class][spec]:Disable()
		end
	end
end

local function InitClassBars()
	local classBarUpdate = CreateFrame("Frame")
	classBarUpdate:RegisterUnitEvent("PLAYER_SPECIALIZATION_CHANGED", "player")
	classBarUpdate:RegisterEvent("PLAYER_TALENT_UPDATE")
	classBarUpdate:RegisterEvent("PLAYER_LEVEL_UP")
	classBarUpdate:SetScript("OnEvent", ClassBarUpdate)
	
	E.GUI.args.unitframes.args.classBars = {
		name = "Панель класса",
		order = 20,
		expand = true,
		type = "group",
		args = {}
	}
	
	ClassBarUpdate()
	
	E.GUI.args.unitframes.args.classBars.args.Enable = {
		name = "Включить",
		order = 1,
		type = "toggle",
		set = function(me, value)
			
			E.db.classBars[class2][currentSpec].enable = not E.db.classBars[class2][currentSpec].enable
			
			ClassBarUpdate()
		end,
		get = function(me)
			return E.db.classBars[class2][currentSpec].enable
		end
	}
end

E:OnInit2(InitClassBars)