﻿local E = AleaUI
local CBF = E:Module("ClassBars")

local class1, class = UnitClass("player")
if class ~= "PALADIN" then return end


local w, h = 80, 10
local maxw, maxh = 200, 10

local HOLY_POWER = "HOLY_POWER"

local HOLYPOWER_NUM_BARS = 5

local function HolyPower()

	local f = CreateFrame("Frame", nil, E.UIParent)
	E:Mover(f, "holypowerFrame", maxw, maxh)
	f.orbs = {}
	f.eventlist = { 
		["UNIT_POWER"]		= "player",
		}


	f:SetSize(maxw, maxh)
	
	local o = CreateFrame("StatusBar", nil, f)
	o:SetSize(maxw, maxh)
	o:SetStatusBarTexture([[Interface\Buttons\WHITE8x8]])
	o:SetPoint("LEFT", f, "LEFT", 0, 0)
	o:SetStatusBarColor(1,1,0,1)
	o:SetMinMaxValues(0,HOLYPOWER_NUM_BARS)
	
	o.art = CreateFrame("Frame", nil, o)
	o.art:SetFrameLevel(o:GetFrameLevel()-1)
	o.art:SetBackdrop({
	  bgFile = [[Interface\Buttons\WHITE8x8]], 
	  edgeFile = [[Interface\Buttons\WHITE8x8]], 
	  edgeSize = 1, 
	})
	o.art:SetBackdropColor(1*0.4,1*0.4,0*0.4, 1)
	o.art:SetBackdropBorderColor(0,0,0,1)
	o.art:SetPoint('TOPLEFT', o, 'TOPLEFT', -1, 1)
	o.art:SetPoint('BOTTOMRIGHT', o, 'BOTTOMRIGHT', 1, -1)

	f.bar = o
	
	f.bar.separators = {}
	
	for i=1, HOLYPOWER_NUM_BARS-1 do
		local s = f.bar:CreateTexture()
		s:SetDrawLayer('ARTWORK', 1)
		s:SetSize(1, maxh)
		s:SetColorTexture(0,0,0,1)
		s:SetPoint('LEFT', f.bar, 'LEFT', maxw/HOLYPOWER_NUM_BARS*i, 0)
		
		f.bar.separators[i] = s
	end
	
	function f:UNIT_POWER(event, unit, powerType)	
	
		if unit == "player" and powerType == HOLY_POWER then
			local power = UnitPower("player", 9)
			f.bar:SetValue(power)
		end
	end
	
	f:UNIT_POWER(_, "player", HOLY_POWER)
	
	E.GUI.args.unitframes.args.classBars.args.unlock = {
		name = "Разблокировать",
		order = 2,
		type = "execute",
		set = function(self, value)
			E:UnlockMover("holypowerFrame") 
		end,
		get = function(self)end
	}
	
	return f
end

CBF:AddClassBar(class, 1, HolyPower)
CBF:AddClassBar(class, 2, HolyPower)
CBF:AddClassBar(class, 3, HolyPower)