﻿local E = AleaUI

if not E.IsClass("WARLOCK") then return end

local CBF = E:Module("ClassBars")
local class = "WARLOCK"

local w, h = 50, 10
local maxw, maxh = 200, 10

local SPELL_POWER_SOUL_SHARDS = SPELL_POWER_SOUL_SHARDS
local NUM_SOUL_SHARDS = E.IsLegion and 5 or 4

local color = { RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b, 1 }

local function SouldShards()
	local f = CreateFrame("Frame", nil, E.UIParent)
	E:Mover(f, "soulshardFrame", maxw, maxh)
	
	f.orbs = {}
	f.eventlist = {
		["UNIT_POWER_FREQUENT"]		= "player",
		["UNIT_DISPLAYPOWER"]		= "player",
		}
	
		f:SetSize(maxw, 10)
		
	local o = CreateFrame("StatusBar", nil, f)
	o:SetFrameLevel(f:GetFrameLevel()+1)
	o:SetSize(maxw, maxh)
	o:SetStatusBarTexture([[Interface\Buttons\WHITE8x8]])
	o:SetPoint("LEFT", f, "LEFT", 0, 0)
	o:SetStatusBarColor(unpack(color))
	o:SetMinMaxValues(0, NUM_SOUL_SHARDS*( E.IsLegion and 1 or 100 ) )
	
	o.art = CreateFrame("Frame", nil, o)
	o.art:SetFrameLevel(o:GetFrameLevel()-1)
	o.art:SetBackdrop({
	  bgFile = [[Interface\Buttons\WHITE8x8]], 
	  edgeFile = [[Interface\Buttons\WHITE8x8]], 
	  edgeSize = 1, 
	})
	o.art:SetBackdropColor(color[1]*0.4,color[2]*0.4,color[3]*0.4, 1)
	o.art:SetBackdropBorderColor(0,0,0,1)
	o.art:SetPoint('TOPLEFT', o, 'TOPLEFT', -1, 1)
	o.art:SetPoint('BOTTOMRIGHT', o, 'BOTTOMRIGHT', 1, -1)
	
	f.bar = o
	
	f.bar.separators = {}
	
	for i=1, NUM_SOUL_SHARDS-1 do
		local s = f.bar:CreateTexture()
		s:SetDrawLayer('ARTWORK', 1)
		s:SetSize(1, maxh)
		s:SetColorTexture(0,0,0,1)
		s:SetPoint('LEFT', f.bar, 'LEFT', maxw/NUM_SOUL_SHARDS*i, 0)
		
		f.bar.separators[i] = s
	end
	
	function f:UNIT_POWER_FREQUENT(event, unit, powerType)	
	
		if("player" ~= unit or (powerType and powerType ~= "SOUL_SHARDS")) then return end
		local numOrbs = E.IsLegion and UnitPower("player", SPELL_POWER_SOUL_SHARDS) or UnitPower("player", SPELL_POWER_SOUL_SHARDS, true)
	
		f.bar:SetValue(numOrbs)
	end
	
	f.UNIT_DISPLAYPOWER = f.UNIT_POWER_FREQUENT
	f.PLAYER_REGEN_ENABLED = f.PLAYER_REGEN_ENABLED
	
	f:UNIT_POWER_FREQUENT(_, "player", "SOUL_SHARDS")
	
	f.Update = function(self)
		self:UNIT_POWER_FREQUENT(_, "player", "SOUL_SHARDS")
	end
	
	E.GUI.args.unitframes.args.classBars.args.unlock = {
		name = "Разблокировать",
		order = 2,
		type = "execute",
		set = function(self, value)
			E:UnlockMover("soulshardFrame") 
		end,
		get = function(self)end
	}
	
	return f
end

CBF:AddClassBar(class, 1, SouldShards)
CBF:AddClassBar(class, 2, SouldShards)
CBF:AddClassBar(class, 3, SouldShards)