local Skins = AleaUI:Module("Skins")
local _G = _G

local default_background_color = Skins.default_background_color
local default_border_color = Skins.default_border_color
local default_font = Skins.default_font
local default_texture = Skins.default_texture

local default_button_background = Skins.default_button_background
local default_button_border 	= Skins.default_button_border
local default_border_color_dark = Skins.default_border_color_dark

local varName = 'encounterjournal'
AleaUI.default_settings.skins[varName] = true

local function EncounterJournalStyle()
	if not AleaUI.db.skins.enableAll then return end
	if not AleaUI.db.skins[varName] then return end

	_G['EncounterJournal']:StripTextures()
		
	local defaultPoint = "TOPLEFT"
	local defaultParent = EncounterJournal
	local defaultAnchor = 'TOPLEFT'
	local defaultXpos = 3 
	local defaultYpos = -30

	Skins.ThemeBackdrop('EncounterJournal')	
--	WorldMapFrame.BorderFrame:StripTextures()
	_G['EncounterJournalInset']:StripTextures()
	
	_G['EncounterJournalNavBar']:StripTextures()
	_G['EncounterJournalNavBarOverlay']:StripTextures()
	Skins.ThemeBackdrop('EncounterJournalNavBar')
	
	Skins.ThemeEditBox('EncounterJournalSearchBox', true) --, realSize, width, height)
	
	Skins.ThemeDropdown('EncounterJournalInstanceSelectTierDropDown')
	
	Skins.ThemeButton(EncounterJournalSuggestFrame.Suggestion1.button)
	Skins.ThemeButton(EncounterJournalSuggestFrame.Suggestion2.centerDisplay.button)
	Skins.ThemeButton(EncounterJournalSuggestFrame.Suggestion3.centerDisplay.button)
	
	Skins.ThemeScrollBar('EncounterJournalInstanceSelectScrollFrameScrollBar')
	Skins.ThemeScrollBar('EncounterJournalEncounterFrameInfoBossesScrollFrameScrollBar')
	Skins.ThemeScrollBar('EncounterJournalEncounterFrameInfoOverviewScrollFrameScrollBar')
	Skins.ThemeScrollBar('EncounterJournalEncounterFrameInstanceFrameLoreScrollFrameScrollBar')
	Skins.ThemeScrollBar('EncounterJournalEncounterFrameInfoLootScrollFrameScrollBar')
	Skins.ThemeScrollBar('EncounterJournalEncounterFrameInfoDetailsScrollFrameScrollBar')
	
	EncounterJournalNavBar:ClearAllPoints()
	EncounterJournalNavBar:SetPoint(defaultPoint, defaultParent, defaultAnchor, defaultXpos, defaultYpos)

	hooksecurefunc(EncounterJournalNavBar, 'SetPoint', function(self, point, parent, anchor, xpos, ypos)
		if ( point ~= defaultPoint ) or 
		   ( parent ~= defaultParent ) or
		   ( anchor ~= defaultAnchor ) or 
		   ( xpos ~= defaultXpos ) or
		   ( ypos ~= defaultYpos ) then
			
			EncounterJournalNavBar:ClearAllPoints()
			EncounterJournalNavBar:SetPoint(defaultPoint, defaultParent, defaultAnchor, defaultXpos, defaultYpos)

		end
	end)
	
	
	Skins.ThemeIconButton(EncounterJournalSuggestFramePrevButton)
	Skins.ThemeIconButton(EncounterJournalSuggestFrameNextButton)
end
AleaUI:OnAddonLoad('Blizzard_EncounterJournal', EncounterJournalStyle)
